#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream>

#define MAX_LEN 1000

using namespace std;

double totaltime;
long totalnodes;
char version[100];
char hash[100];
char hashp[100];

//look if a string starts with 'search'
bool beginsWith(char *str, char *search)
{
	return strncmp(str, search, strlen(search)) == 0;
}

//look if a string starts with 'search' and deletes it it finds
bool beginsWithAndDelete(char* &str, char *search)
{
	int lengte = (int)strlen(search);
	bool result = strncmp(str, search, lengte) == 0;

	if (result) str += lengte;

	return result;
}


//look if a string starts with 'search' and deletes it it finds
bool midAndDelete(char* &str, char *search)
{
   char *pos = strstr(str, search);

   if (pos) str = pos+strlen(search);

   return pos != NULL;
}

//deletes starting spaces
void ltrim(char *str)
{
	while(str[0] == ' ') strcpy(str, str+1);
}

//deletes trailing spaces, returns, etc
void rtrim(char *str)
{
	int lengte = (int)strlen(str);

	while (lengte != 0)
	{
		if (str[lengte-1] == '\n' ||
			str[lengte-1] == '\r' ||
			str[lengte-1] == ' ') 
		{
			lengte--;
		}
		else
		{
			break;
		}
	}

	str[lengte] = '\0';
	
}

//print the score list
void printResult()
{
   printf("totalnodes= %d\n", totalnodes);
   printf("totaltime= %.2f\n", totaltime);
	printf("nps= %.1f\n", totalnodes/totaltime);
}

//get a string part of a string seperated with 'c'
//the first part is 0, the 2nd part 1, etc
void gettoken(char *str, char c, int searchnumber, char *buffer)
{
	int number = 0;
	char *strbuffer = buffer;

	for (int i=0; i<(int)strlen(str); i++)
	{
		if (str[i] == c) 
		{
			number++; 
		}
		else if (number == searchnumber)
		{
			*strbuffer = str[i];
			strbuffer++;
		}
	}

	*strbuffer = '\0';
}

//look how many times character 'c' occures in the string 'str'
int getcount(char *str, char c)
{
	int number = 0;

	for (int i=0; i<(int)strlen(str); i++)
	{
		if (str[i] == c) number++;
	}

	return number;
}


double calctime(char *str)
{
   char min[10];
   char sec[10];

   if (getcount(str, ':') == 1)
   {
      gettoken(str, ':', 0, min);
      gettoken(str, ':', 1, sec);
      return atoi(min) * 60 + atof(sec);
   }
   else
   {
      return atof(str);
   }
}

void parseLine(char *str)
{
   char time[100];

	if (beginsWithAndDelete(str, "Crafty v"))
	{
      strcpy(version, str);
      printf("version= %s\n", version);
	}

	if (beginsWithAndDelete(str, "hash table memory = "))
	{
      strcpy(hash, str);
      printf("hash = %s\n", hash);
	}

   if (beginsWithAndDelete(str, "pawn hash table memory = "))
	{
      strcpy(hash, str);
      printf("hash = %s\n", hash);
	}

   if (midAndDelete(str, "time="))
   {
      gettoken(str, ' ', 0, time);
      printf("time found = %s that is %.2f sec\n", time, calctime(time));
      totaltime += calctime(time);
   }

   if (midAndDelete(str, "  n="))
   {
      totalnodes += atol(str);
   }
}

void parseFile(char *strFileName)
{
   char line[MAX_LEN];

	FILE *f = fopen(strFileName, "r");
	if (f == NULL)
	{
		cerr << "Error opening " << strFileName << endl;
		exit(1);
	}

	while (fgets(line, MAX_LEN, f) != NULL)
	{
		rtrim(line);
		ltrim(line);
		char *str = (char*)&line;

      parseLine(str);
	}
}

int main(int argc, char* argv[])
{
	if (argc < 2)
	{
      cerr << "CRAFTYLOG2NPS v1.0 by Michel Langeveld 2003" << endl;
      cerr << "Please report errors to michel.langeveld@xs4all.nl" << endl << endl;
		cerr << "Usage: craftylog2nps <crafty-log-file>" << endl;
		exit(1);
	}

   parseFile(argv[1]);
   printResult();

	return 0;
}

